﻿init python:
    class phone_contact:
        def __init__(self, id, name = None, number = None, img = None, sms = [], current = None, times = None):
            self.id = id
            self.name = name
            self.number = number
            self.img = img
            self.sms = sms
            self.typing = ""
            self.current = current
            self.times = times
            self.phase = 0
            self.unread = 0
        def add(self, sender, message, times):
            if times is not None:
                self.times = times
            else:
                self.times = [500, len(message)*40, 500]

            self.current = [sender, message]
            self.phase = 0
            # return

        def tick(self):
            if self.current[0] == self.id:
                if self.times is not None:
                    if len(self.times) > 0:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            if self.phase == 0:
                                self.phase = 1
                            else:
                                self.phase = 0
                        else:
                            self.times[0] -= 100
                        return False
                    else:
                        self.sms.append(self.current)
                        self.current = None
                        self.times = None
                        return True
            else:
                if self.times is not None:
                    if self.phase == 0:
                        if self.times[0] <= 0:
                            self.times.pop(0)
                            if self.phase == 0:
                                self.phase = 2
                            else:
                                self.phase = 0
                        else:
                            self.times[0] -= 100
                        return False
                    elif self.phase == 2:
                        if len(self.current[1]) == len(self.typing):
                            self.phase = 3
                        else:
                            self.typing += self.current[1][len(self.typing)]
        def send(self):
            self.sms.append(self.current)
            self.current = None
            self.times = None
            self.phase = 0
            self.typing = ""
            return True
    class phone_class:
        def __init__(self, owner, id, img = None):
            self.owner = owner
            self.id = id
            self.img = img
            self.active = None
            self.open = None
            self.stat = "Closed"
            self.contacts = []
            self.typing = ""
            self.showing = None
            self.wiggle = 0
            
        def show(self, screen, sender = None):
            self.showing = screen
            if screen == "sms list":
                renpy.show_screen("phone_sms_list", self)
                self.unread = 0
            if screen == "sms":
                for i in self.contacts:
                    if i.id == sender:
                        self.active = i
                renpy.show_screen("phone_sms", self)

        def sms(self, contact, message, sender, times):
            if not sender:
                sender = self.id

            for i in self.contacts:
                if i.id == contact:
                    i.add(sender, message, times)
                    break
            else:
                self.contacts.append(phone_contact(contact, current = [sender, message], times = times))
            renpy.pause(hard=True)
            

        def add(self, id, name = None, number = None, img = None):
            for i in self.contacts:
                if i.id == id:
                    if name:
                        i.name = name
                    if number:
                        i.number = number
                    if img:
                        i.img = img
            else:
                self.contacts.append(phone_contact(id, name, number, img))

        def tick(self):
            if self.wiggle:
                self.wiggle -= 1
            for i in self.contacts:
                if i.current:
                    
                    if i.tick():
                        if self.showing == "sms":
                            renpy.hide_screen("phone_sms")
                            renpy.show_screen("phone_sms", self)
                        else:
                            renpy.play("phone/sms.ogg", "sound")
                            self.wiggle = 10
            
                        return 1








            
